
  function format_date (gsdate,mode) 
  {
       var year_num  = gsdate.substr(0,4);
       var month_num = gsdate.substr(4,2);
       var date_num  = gsdate.substr(6,2);

       var date = new Date(year_num,month_num-1,date_num)

       var date_str = date.toLocaleDateString();

       if ((mode != undefined) && (mode == "alphanum"))
       {
           var dayname   = new Array("Sunday","Monday","Tuesday","Wednesday",
                                     "Thursday","Friday","Saturday");
           var monthname = new Array("Jan","Feb","Mar","Apr","May","Jun","Jul",
                                     "Aug","Sep","Oct","Nov","Dec");

           var day_alpha   = dayname[date.getDay()];
           var month_alpha = monthname[date.getMonth()];

           date_str = day_alpha +", "
                       + date_num +" "+ month_alpha +" "+ year_num;
        }

       document.write(date_str);
  }

  function format_filesize (gsfilesize) 
  {
      var filesize = gsfilesize + " bytes";

      if (gsfilesize > 1048576) {
        filesize = Math.round(gsfilesize / 1048576.0) + " Mb"
      }
      else if (gsfilesize > 1024) {
        filesize = Math.round(gsfilesize / 1024.0) + " Kb"
      }

      document.write(filesize);
  }



function getOpenBookTable() {

        var tabTocA = document.getElementById("toc");

        // book icon and toc wrapper
        var tablesOuter = tabTocA.parentNode.getElementsByTagName("table")

        return tablesOuter.item(0);

}

function getTocTable() {

        var tabTocA = document.getElementById("toc");

        // book icon and toc wrapper
        var tablesOuter = tabTocA.parentNode.getElementsByTagName("table")
        
        var tabWrap = tablesOuter.item(1);

        var tables = tabWrap.getElementsByTagName("table")

        return tables.item(0);

}




function manipulateTocTable() {

	var tabOB= getOpenBookTable();

	if (tabOB != null) {
	  var expandText = document.getElementById("db-expand-text");
	  var highlight  = document.getElementById("db-highlight");
	  var parentDB = expandText.parentNode;

	  parentDB.removeChild(expandText);
	  parentDB.removeChild(highlight);

	  var tbodyOB = tabOB.firstChild;
	  var trOB = tbodyOB.firstChild;
	  trOB.appendChild(expandText);
	  trOB.appendChild(highlight);

	  tabOB.setAttribute("width","100%");
	  
  	  // tabOB.setAttribute("bgcolor","red");
	}


	var tabToc= getTocTable();

	if (tabToc != null) {

	    var tablePack = document.createElement("table");
	    var tbodyPack = document.createElement("tbody");
	    tablePack.appendChild(tbodyPack);

	    var trPack = document.createElement("tr");
	    trPack.setAttribute("bgColor","#e0f0ff");


  	    var trList = tabToc.getElementsByTagName("tr")

	    // repack into 3-col table
	    var i;
	    for (i=0; i<trList.length; i++) {
	      if ((i>0) && (i % 3 == 0)) {
	        tbodyPack.appendChild(trPack);
	        trPack = document.createElement("tr");
		trPack.setAttribute("bgColor","#e0f0ff");
	      }
	      var tr = trList.item(i);
	      var tdList = tr.getElementsByTagName("td");

	      //console.log("tdList = " + tdList.length);

	      var tdLink = tdList.item(0);
	      var href = tdLink.firstChild.href;

	      href = "javascript:htmlLoad(\""+href+"&onlytext=1\",\"ajaxtext\")";

	      var tdText = tdList.item(2);

	      var aPack = document.createElement("a");
	      aPack.setAttribute("href",href);
	      aPack.setAttribute("class","toc");
	      aPack.innerHTML = tdText.innerHTML;

	      var iPack = document.createElement("i");
	      iPack.appendChild(aPack);

	      //var tdPack = tdText.cloneNode(true);
	      var tdPack = document.createElement("td");
	      tdPack.appendChild(iPack);

	      // var textText = document.createTextNode(tdText.innerHTML);

	      // tdPack.appendChild(textText);

	      // tdPack.setAttribute("bgcolor","blue");
	      trPack.appendChild(tdPack);

	    }

	    tbodyPack.appendChild(trPack);

	    // find outer table element, and replace with new compact TOC
	    var newTocLoc = tabToc.parentNode;
	    while (!newTocLoc.nodeName.match(/^table$/i)) {
	        newTocLoc = newTocLoc.parentNode;
	    }

	    
	    // set up list of TOC chapter headings (used when video player is shown)

	    //var tocList = document.createElement("div");
	    //tocList.setAttribute("style","display: block");

	    var tocList  = document.getElementById("toclist");

	    for (i=0; i<trList.length; i++) {
	      var tr = trList.item(i);
	      var tdList = tr.getElementsByTagName("td");
	      var tdText = tdList.item(1);

	      // alert("tdText = " + tdText.innerHTML);

	      var tocEntry = document.createElement("div");
	      tocEntry.style.display = "none";

	      tocEntry.innerHTML = tdText.innerHTML;

	      //tocEntry.appendChild(tdText);

	      tocList.appendChild(tocEntry);
	    }
	

	    // delay replace until here so toclist can access trList
	    // in IE, doing replace earlier means trList becomes empty
	    newTocLoc.parentNode.replaceChild(tablePack,newTocLoc);    

	}
	else {
	  var mess = "Warning: Didn't find TOC table where expected in DOM";
	  mess += "\n Found <" + tabToc.nodeName + ">instead of <table>";
	  mess += "\n Unable to manipulate: " + tabToc.nodeValue;
 
	  alert(mess);
	}

}


    var flowplayervisible = 1;
    var storedFlowplayerHeight = null;

    function flowplayershow() 
     {
        if (flowplayervisible) return; // already visible

        divTOCtableElem = document.getElementById("toctable");
	divTOCtableElem.style.display = "none";

        divTOCnextprevElem = document.getElementById("tocnextprev");
	divTOCnextprevElem.style.display = "block";

        var divFlowplayerElem = document.getElementById("FlowPlayerDiv");
	divFlowplayerElem.style.visibility = "visible";

	if (storedFlowplayerHeight != null) {
	    divFlowplayerElem.style.height = storedFlowplayerHeight;
        }

	var flowPlayer = document.getElementById("FlowPlayer");

	if (flowPlayer.DoPlay) {
	    flowPlayer.DoPlay();
	}

        flowplayervisible = 1;
      }

    function flowplayerhide() 
     {
        if (!flowplayervisible) return; // already hidden


        divTOCnextprevElem = document.getElementById("tocnextprev");
	divTOCnextprevElem.style.display = "none";

        var divFlowplayerElem = document.getElementById("FlowPlayerDiv");

	if (parseInt(divFlowplayerElem.style.height) != "0") {
	    storedFlowplayerHeight = divFlowplayerElem.style.height;
	}
	divFlowplayerElem.style.height = "0px";
	divFlowplayerElem.style.visibility = "hidden";

        divTOCtableElem = document.getElementById("toctable");
	divTOCtableElem.style.display = "block";

        var flowPlayer = document.getElementById("FlowPlayer");

	if (flowPlayer.Pause) {
	    flowPlayer.Pause();
	}

        flowplayervisible = 0;
      }

    var storedseek;
    var delayedSafetyLimit = 0;

    function videoplayerseekDelayed() 
     {
          var flowPlayer = document.getElementById("FlowPlayer");

          if (flowPlayer.Seek) {
	     flowPlayer.Pause();
	     flowPlayer.Seek(storedseek);
	     flowPlayer.DoPlay()
          }
	  else {
	     if (delayedSafetyLimit<10) {
	       delayedSafetyLimit++;
	       setTimeout("videoplayerseekDelayed()",2000);
             }
	     else {
	       alert("Failed to start at seeked position " + storedseek);
	     }
	  }

      }


    function videoplayerseek(hh,mm,ss) 
     {
	  flowplayershow();

          storedseek = hh*3600 + mm*60 + ss -2;

          var flowPlayer = document.getElementById("FlowPlayer");

          if (flowPlayer.Seek) {
	      videoplayerseekDelayed();
          }
	  else {
	     delayedSafetyLimit = 0;
	     setTimeout("videoplayerseekDelayed()",7000);
	  }

      }

    function audioplayerseek(hh,mm,ss) 
     {
          storedseek = hh*3600 + mm*60 + ss -2;

          var flowPlayer = document.getElementById("FlowPlayer");

          if (flowPlayer.Seek) {
	      videoplayerseekDelayed();
          }
	  else {
	     delayedSafetyLimit = 0;
	     setTimeout("videoplayerseekDelayed()",7000);
	  }

      }


      function onCuePoint(cuePoint) 
      {
           if (cuePoint.type != "event") { return; }

	  var tocList = document.getElementById("toclist");

	  var tocEntries = tocList.getElementsByTagName("div");
	  var parameters = cuePoint.parameters;
	  var secNum = cuePoint.parameters.sectionnum;

	  var tocNum = secNum-1;

	  tocLen = tocEntries.length;

	  var i;
	  for (i=0; i<tocLen; i++)
	  {
	        var tocItem = tocEntries.item(i);

	        if (i==tocNum-1) {
		  var prevImg = document.getElementById("tocless");
		  prevImg.setAttribute("title",tocItem.innerHTML);
		}


		if (i!=tocNum) {
	          tocItem.style.display = "none";
		}
		else {
	          tocItem.style.display = "block";

		  // load in matching document-section text
		  var url = document.location.toString();

		  var nexturl = url;
		  var nextSecNum = tocNum + 1;

		  var doccutoff = url.lastIndexOf("&d=");
		  var dotcutoff = url.lastIndexOf(".");

		  if (dotcutoff>doccutoff) {
		    nexturl = url.substring(0,dotcutoff);
		  }

		  nexturl = nexturl + "." + nextSecNum + "&onlytext=1";
		  //alert("nexturl = " + nexturl);

		  htmlLoad(nexturl,"ajaxtext");

		}

	        if (i==tocNum+1) {
		  var moreImg = document.getElementById("tocmore");
		  moreImg.setAttribute("title",tocItem.innerHTML);
		}

	  }


      }




  function htmlLoad(url,locid)
  {
    var xmlHttp;
    try {
      // Firefox, Opera 8.0+, Safari
      xmlHttp=new XMLHttpRequest();
    }
    catch (e) {
      // Internet Explorer
      try {
        xmlHttp=new ActiveXObject("Msxml2.XMLHTTP");
      }
      catch (e) {
        try {
          xmlHttp=new ActiveXObject("Microsoft.XMLHTTP");
        }
        catch (e) {
          alert("Your browser does not support AJAX!");
          return false;
        }
      }
    }

    xmlHttp.onreadystatechange=function() {
      if(xmlHttp.readyState==4) {
        var locelem = document.getElementById(locid);
        
        locelem.innerHTML = xmlHttp.responseText;
      }
    }

    xmlHttp.open("GET",url,true);
    xmlHttp.send(null);
  }

  
  
  
  function displayDateTimeLocale(datetimebroadcasted) 
	{
	 var year = datetimebroadcasted.substr(0,4);
	 var month = datetimebroadcasted.substr(4,2);
	 var day = datetimebroadcasted.substr(6,2);
	 var hours = datetimebroadcasted.substr(8,2);
	 var minutes = datetimebroadcasted.substr(10,2);
	 var seconds = datetimebroadcasted.substr(12,2);
	 var date = new Date(year, month*1-1, day, hours, minutes, seconds)
	 document.write(date.toLocaleString());
	}
	
	function displayRemainingDaysToKeep(datetimebroadcasted,daysToKeep)
	{
	 var oneDayInMs = 1000*60*60*24;
	 var year = datetimebroadcasted.substr(0,4);
	 var month = datetimebroadcasted.substr(4,2);
	 var day = datetimebroadcasted.substr(6,2);
	 var displayString = "";
	 var importedDate = new Date(year, month*1-1, day);
	 var nowDate = new Date();
	 var endDate = new Date(year, month*1-1, day*1+daysToKeep);
	 var daysLeft = Math.ceil((endDate.getTime()-nowDate.getTime())/(oneDayInMs));
	 
	 if (daysLeft >= 1)
		{ displayString = "This video has " + daysLeft + " day(s) remaining before expiration."; }
	 else
		{ displayString = "This video has expired, it will be deleted very soon."; }
	 
	 document.write(displayString);
	}